// ManualEditDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "workscheduler.h"
#include "DataManager.h"
#include "EVal.h"

#include "MenuDispCtrl.h"

#include "ManualEditDlg001.h"
#include "ManualEditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// HXgJʒu
#define	COL_KOTEI_SUBLINE		0
#define	COL_KOTEI_KIGOU			1
#define	COL_KOTEI_BANGO			2
#define	COL_KOTEI_NAME			3
#define	COL_KOTEI_JIDOU			4

// vfƌQXgJʒu
#define	COL_YOSOSAGYOGUN_LISTNO		0
#define	COL_YOSOSAGYOGUN_NAME		1

// vfƃXgJʒu
#define	COL_YOSOSAGYO_SAGYONO		0
#define	COL_YOSOSAGYO_YOSOSAGYO		1
#define	COL_YOSOSAGYO_YOSOSAGYONO	2
#define	COL_YOSOSAGYO_M				3
#define	COL_YOSOSAGYO_N				4
#define	COL_YOSOSAGYO_HINDO			5
#define	COL_YOSOSAGYO_KURIKAESI		6
#define	COL_YOSOSAGYO_KOTEI			7
#define	COL_YOSOSAGYO_KIJUN		8

// \F
#define	COLOR_TEXT		RGB(0x00, 0x00, 0x00)
#define	COLOR_KYOTSU	RGB(0xff, 0xff, 0x00)
#define	COLOR_ERROR		RGB(0xff, 0x00, 0x00)

// ҏWtO
#define EDIT_NONE		0
#define EDIT_CHANGE		1
#define EDIT_DELETE		2
#define EDIT_INSERT		3


/////////////////////////////////////////////////////////////////////////////
// CManualEditDlg _CAO


CManualEditDlg::CManualEditDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CManualEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CManualEditDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT

	m_nSublineId = -1;
	m_nSagyoshaId = -1;
}


void CManualEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CManualEditDlg)
	DDX_Control(pDX, IDC_BUTTON_YOSO_SAGYO_TSUIKA, m_cButtonYosoSagyoTsuika);
	DDX_Control(pDX, IDC_BUTTON_YOSO_SAGYO_SAKUJO, m_cButtonYosoSagyoSakujo);
	DDX_Control(pDX, IDC_EDIT_KISHU_NAME, m_cEditKishuName);
	DDX_Control(pDX, IDC_LIST_KOTEI, m_cListKotei);
	DDX_Control(pDX, IDC_LIST_YOSO_SAGYOGUN, m_cListYosoSagyogun);
	DDX_Control(pDX, IDC_LIST_YOSO_SAGYO, m_cListYosoSagyo);
	DDX_Control(pDX, IDC_COMBO_SAGYOSHA, m_cComboSagyosha);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CManualEditDlg, CDialogEx)
	//{{AFX_MSG_MAP(CManualEditDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_SAGYOSHA, OnSelchangeComboSagyosha)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_KOTEI, OnItemchangedListKotei)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_YOSO_SAGYOGUN, OnItemchangedListYosoSagyogun)
	ON_BN_CLICKED(IDC_BUTTON_YOSO_SAGYO_SAKUJO, OnButtonYosoSagyoSakujo)
	ON_BN_CLICKED(IDC_BUTTON_YOSO_SAGYOGUN_SAKUJO, OnButtonYosoSagyogunSakujo)
	ON_BN_CLICKED(IDC_BUTTON_KOTEI_SAKUJO, OnButtonKoteiSakujo)
	ON_BN_CLICKED(IDC_BUTTON_YOSO_SAGYO_TSUIKA, OnButtonYosoSagyoTsuika)
	ON_BN_CLICKED(IDC_BUTTON_YOSO_SAGYOGUN_TSUIKA, OnButtonYosoSagyogunTsuika)
	ON_BN_CLICKED(IDC_BUTTON_KOTEI_TSUIKA, OnButtonKoteiTsuika)
	ON_BN_CLICKED(IDC_BUTTON_PREVIEW, OnButtonPreview)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_USER + 0x0502, CreateComboList)
	ON_MESSAGE(WM_USER + 0x0503, OnChangeCombo)
	ON_MESSAGE(WM_USER + 0x0504, OnChangeEdit)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManualEditDlg bZ[W nh

BOOL CManualEditDlg::OnInitDialog() 
{
	CDialogEx::OnInitDialog();
	
// Modify ... ( CHANGE )
	// vfƃev[gǂݍ
	if (g_pDataManager->GetYosoSagyoTemplateNum() == 0) {
//		if (!g_pDataManager->ReadYosoSagyoTemplate()) {
			EndDialog(IDCANCEL);
			return TRUE;
//		}
	}
// By Y.Itabashi (xxxxx) 2007.02.16

	// j[Ƀj[t@C̕Zbg
	g_pSystem->m_cMenuDisp.SetMenuText( this, Menu_ManualEditDlg );

	// Xg̃JZbg
	SetLixxxolumn( m_cListKotei, Menu_ManualEditDlg, List_ManualEditKotei, eSELECTTYPE_SINGLE );
	SetLixxxolumn( m_cListYosoSagyogun, Menu_ManualEditDlg, List_ManualEditYosoSagyogun, eSELECTTYPE_SINGLE );
	SetLixxxolumn( m_cListYosoSagyo, Menu_ManualEditDlg, List_ManualEditYosoSagyo, eSELECTTYPE_SINGLE );

	m_cListKotei.DeleteAllItems();
	m_cListYosoSagyogun.DeleteAllItems();
	m_cListYosoSagyo.DeleteAllItems();

	// Xgf[^쐬
	MakeSagyoshaList();

	// Ǝ҃R{{bNXݒ
	SetSagyoshaList();

	// ftHg̍Ǝ҂I
	if (m_nSagyoshaId != -1) {
		int nCount = m_cComboSagyosha.GetCount();
		for (int i = 0; i < nCount; i++) {
			int nIndex = m_cComboSagyosha.GetItemData(i);
			if (m_aSagyoshaList[nIndex].nSagyoshaId == m_nSagyoshaId) {
				m_cComboSagyosha.SetCurSel(i);
				OnSelchangeComboSagyosha();
				break;
			}
		}
	}

	// @햼\
	if (m_nKishuId != -1)
		m_cEditKishuName = g_pDataManager->GetKishuData(m_nKishuId)->sKishuName;

	// Rg[̈ʒu𒲐
	SetCtlPosition(IDC_STATIC005, 0, 0, 0, 0.5);
	SetCtlPosition(IDC_LIST_KOTEI, 0, 0, 0, 0.5);
	SetCtlPosition(IDC_STATIC013, 0, 0.5, 0, 1);
	SetCtlPosition(IDC_BUTTON_YOSO_SAGYOGUN_TSUIKA, 0, 0.5, 0, 0.5);
	SetCtlPosition(IDC_BUTTON_YOSO_SAGYOGUN_SAKUJO, 0, 0.5, 0, 0.5);
	SetCtlPosition(IDC_LIST_YOSO_SAGYOGUN, 0, 0.5, 0, 1);
	SetCtlPosition(IDC_STATIC018, 0, 0, 1, 1);
	SetCtlPosition(IDC_BUTTON_YOSO_SAGYO_TSUIKA, 1, 0, 1, 0);
	SetCtlPosition(IDC_BUTTON_YOSO_SAGYO_SAKUJO, 1, 0, 1, 0);
	SetCtlPosition(IDC_LIST_YOSO_SAGYO, 0, 0, 1, 1);
	SetCtlPosition(IDC_BUTTON_PREVIEW, 1, 1, 1, 1);
	SetCtlPosition(IDOK, 1, 1, 1, 1);
	SetCtlPosition(IDCANCEL, 1, 1, 1, 1);

	return TRUE;
}

// Ǝ҃R{{bNXIύX
void CManualEditDlg::OnSelchangeComboSagyosha() 
{
	// HXg\
	SetKoteiList();
}

// HXgIύX
void CManualEditDlg::OnItemchangedListKotei(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// vfƌQXg\
	SetYosoSagyogunList();

	// vfƂ̒ǉE폜{^Lݒ
	EnableYosoSagyoTsuikaSakujo();

	*pResult = 0;
}

// vfƌQXgIύX
void CManualEditDlg::OnItemchangedListYosoSagyogun(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// vfƃXg\
	SetYosoSagyoList();

	*pResult = 0;
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditDlg::SetSagyoshaList
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ǝ҃Xgݒ菈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		E̍Ǝ҃R{{bNXɍƎ҂ݒ肷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//	
//*****************************************************************************************************
void CManualEditDlg::SetSagyoshaList()
{
	int nSize = m_aSagyoshaList.GetSize();
	for (int i = 0; i < nSize; i++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[i];

		// R{{bNXɍƎҖݒ
		m_cComboSagyosha.SetItemData(m_cComboSagyosha.AddString(cSagyoshaList.sSagyoshaName), i);
	}
}

// HXgݒ
void CManualEditDlg::SetKoteiList(int nSelectIndex) 
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];

	// XgNA
	m_cListKotei.DeleteAllItems();
	m_cListYosoSagyogun.DeleteAllItems();
	m_cListYosoSagyo.DeleteAllItems();

	// HXgɃf[^Zbg
	int nRow = 0;
	int nSize = cSagyoshaList.aKoteiList.GetSize();
	for (int i = 0; i < nSize; i++) {
		SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[i];

		if (cKoteiList.nEditFlag != EDIT_DELETE) {
			// eJɃf[^Zbg
			m_cListKotei.SetValue(nRow, COL_KOTEI_SUBLINE, cKoteiList.sSubline);
			m_cListKotei.SetValue(nRow, COL_KOTEI_KIGOU, cKoteiList.sKoteiKigo);
			m_cListKotei.SetValue(nRow, COL_KOTEI_BANGO, cKoteiList.sKoteiNo);
			m_cListKotei.SetValue(nRow, COL_KOTEI_NAME, cKoteiList.sKoteiName);
			m_cListKotei.SetValue(nRow, COL_KOTEI_JIDOU, cKoteiList.sJidoShudo);

			// ʍHFɂ
			if (cKoteiList.bKyotsuKotei)
				m_cListKotei.SetItemRowColor( nRow, COLOR_TEXT, COLOR_KYOTSU );

			// G[sԐFɂ
			if (cKoteiList.bErrorFlag)
				m_cListKotei.SetItemRowColor( nRow, COLOR_TEXT, COLOR_ERROR );

			// sIDZbg
			m_cListKotei.SetItemRowData(nRow, i);

			// w肳ꂽsIԂɂ
			if (i == nSelectIndex)
				m_cListKotei.SelectChange(nRow);

			nRow++;
		}
	}
}

// vfƌQXgݒ
void CManualEditDlg::SetYosoSagyogunList(int nSelectIndex)
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	// IĂH擾
	int nSelectKotei = GetSelectKotei();
	if (nSelectKotei == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];
	SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nSelectKotei];

	// XgNA
	m_cListYosoSagyogun.DeleteAllItems();
	m_cListYosoSagyo.DeleteAllItems();

	// vfƌQXgɗvfƌQݒ
	int nRow = 0;
	int nSize = cKoteiList.aYosoSagyogunList.GetSize();
	for (int i = 0; i < nSize; i++) {
		SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[i];

		if (cYosoSagyogunList.nEditFlag != EDIT_DELETE) {
			// eJɃf[^Zbg
			m_cListYosoSagyogun.SetValue(nRow, COL_YOSOSAGYOGUN_LISTNO, nRow + 1);
			m_cListYosoSagyogun.SetValue(nRow, COL_YOSOSAGYOGUN_NAME, cYosoSagyogunList.sYosoSagyogunName);

			// ʍHFɂ
			if (cYosoSagyogunList.bKyotsuKotei)
				m_cListYosoSagyogun.SetItemRowColor( nRow, COLOR_TEXT, COLOR_KYOTSU );

			// G[sԐFɂ
			if (cYosoSagyogunList.bErrorFlag)
				m_cListYosoSagyogun.SetItemRowColor( nRow, COLOR_TEXT, COLOR_ERROR );

			// sIDZbg
			m_cListYosoSagyogun.SetItemRowData(nRow, i);

			// w肳ꂽsIԂɂ
			if (i == nSelectIndex)
				m_cListYosoSagyogun.SelectChange(nRow);

			nRow++;
		}
	}
}

// vfƃXgݒ
void CManualEditDlg::SetYosoSagyoList(int nSelectIndex)
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	// IĂH擾
	int nSelectKotei = GetSelectKotei();
	if (nSelectKotei == -1)
		return;

	// IĂvfƌQ擾
	int nSelectYosoSagyogun = GetSelectYosoSagyogun();
	if (nSelectYosoSagyogun == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];
	SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nSelectKotei];
	SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nSelectYosoSagyogun];

	// XgNA
	m_cListYosoSagyo.DeleteAllItems();

	// H͗vfƂ\Ȃ
	if (cKoteiList.sJidoShudo == g_pConst->m_sJido)
		return;

	// vfƃXgɗvfƂݒ
// --Add 2007/02/26 aizawa sD-187
	int nAdjust = 0;
// --Add
	int nRow = 0;
	int nSize = cYosoSagyogunList.aYosoSagyoList.GetSize();
	for (int i = 0; i < nSize; i++) {
		SYosoSagyoList &cYosoSagyoList = cYosoSagyogunList.aYosoSagyoList[i];

// --Add 2007/02/26 aizawa sD-187
		// ǉ폜ɂNo␳
		if (cYosoSagyoList.nEditFlag == EDIT_INSERT)
			nAdjust++;
		else if (cYosoSagyoList.nEditFlag == EDIT_DELETE)
			nAdjust--;
// --Add

		if (cYosoSagyoList.nEditFlag != EDIT_DELETE) {
			// eJɃf[^Zbg
// --Change 2007/02/26 aizawa sD-187
//			m_cListYosoSagyo.SetValue(nRow, COL_YOSOSAGYO_SAGYONO, nRow + 1);
			m_cListYosoSagyo.SetValue(nRow, COL_YOSOSAGYO_SAGYONO, cYosoSagyoList.nSagyoNo + nAdjust);
// --Change
			m_cListYosoSagyo.SetValue(nRow, COL_YOSOSAGYO_YOSOSAGYO, cYosoSagyoList.sYosoSagyoName);
			m_cListYosoSagyo.SetValue(nRow, COL_YOSOSAGYO_YOSOSAGYONO, cYosoSagyoList.sYosoSagyoNo);
			if (cYosoSagyoList.bM)
				m_cListYosoSagyo.SetValue(nRow, COL_YOSOSAGYO_M, cYosoSagyoList.fM);
			if (cYosoSagyoList.bN)
				m_cListYosoSagyo.SetValue(nRow, COL_YOSOSAGYO_N, cYosoSagyoList.fN);
			if (cYosoSagyoList.bHassexxxndo)
				m_cListYosoSagyo.SetValue(nRow, COL_YOSOSAGYO_HINDO, cYosoSagyoList.nHassexxxndo);
			if (cYosoSagyoList.bKurikaeshiKaisu)
				m_cListYosoSagyo.SetValue(nRow, COL_YOSOSAGYO_KURIKAESI, cYosoSagyoList.nKurikaeshiKaisu);
			m_cListYosoSagyo.SetValue(nRow, COL_YOSOSAGYO_KOTEI, cYosoSagyoList.sKoteibuHendobu);
			if (cYosoSagyoList.bKijunKotei)
				m_cListYosoSagyo.SetValue(nRow, COL_YOSOSAGYO_KIJUN, GetKijunKoteiString(cYosoSagyoList.nKijunKotei));

			// G[sԐFɂ
			if (cYosoSagyoList.bErrorFlag)
				m_cListYosoSagyo.SetItemRowColor( nRow, COLOR_TEXT, COLOR_ERROR );

			// sIDZbg
			m_cListYosoSagyo.SetItemRowData(nRow, i);

			// w肳ꂽsIԂɂ
			if (i == nSelectIndex)
				m_cListYosoSagyo.SelectChange(nRow);

			nRow++;
		}
	}
}

// HXg̍폜
void CManualEditDlg::OnButtonKoteiSakujo() 
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	// IĂH擾
	int nSelectKotei = GetSelectKotei();
	if (nSelectKotei == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];
	SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nSelectKotei];

	// smFbZ[W
	if (cKoteiList.bKyotsuKotei) {
		if (g_pSystem->DispMessage("W014003") == IDCANCEL)
			return;
	} else {
		if (g_pSystem->DispMessage("W014006") == IDCANCEL)
			return;
	}

	// 폜Ԃɐݒ
	cKoteiList.nEditFlag = EDIT_DELETE;

	// HXg\
	SetKoteiList();
}

// vfƌQXg̍폜
void CManualEditDlg::OnButtonYosoSagyogunSakujo() 
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	// IĂH擾
	int nSelectKotei = GetSelectKotei();
	if (nSelectKotei == -1)
		return;

	// IĂvfƌQ擾
	int nSelectYosoSagyogun = GetSelectYosoSagyogun();
	if (nSelectYosoSagyogun == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];
	SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nSelectKotei];
	SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nSelectYosoSagyogun];

	// smFbZ[W
	if (cYosoSagyogunList.bKyotsuKotei) {
		if (g_pSystem->DispMessage("W014004") == IDCANCEL)
			return;
	} else {
		if (g_pSystem->DispMessage("W014007") == IDCANCEL)
			return;
	}

	// 폜Ԃɐݒ
	cYosoSagyogunList.nEditFlag = EDIT_DELETE;

	// vfƌQXg\
	SetYosoSagyogunList();
}

// vfƃXg̍폜
void CManualEditDlg::OnButtonYosoSagyoSakujo() 
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	// IĂH擾
	int nSelectKotei = GetSelectKotei();
	if (nSelectKotei == -1)
		return;

	// IĂvfƌQ擾
	int nSelectYosoSagyogun = GetSelectYosoSagyogun();
	if (nSelectYosoSagyogun == -1)
		return;

	// IĂvfƎ擾
	int nSelectYosoSagyo = GetSelectYosoSagyo();
	if (nSelectYosoSagyo == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];
	SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nSelectKotei];
	SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nSelectYosoSagyogun];
	SYosoSagyoList &cYosoSagyoList = cYosoSagyogunList.aYosoSagyoList[nSelectYosoSagyo];

	// smFbZ[W
	if (cYosoSagyogunList.bKyotsuKotei) {
		if (g_pSystem->DispMessage("W014005") == IDCANCEL)
			return;
	} else {
		if (g_pSystem->DispMessage("W014008") == IDCANCEL)
			return;
	}

	// 폜Ԃɐݒ
//	cYosoSagyoList.nEditFlag = EDIT_DELETE;
	if (cYosoSagyoList.nYosoSagyoId == -1)
		cYosoSagyogunList.aYosoSagyoList.RemoveAt(nSelectYosoSagyo);
	else
		cYosoSagyoList.nEditFlag = EDIT_DELETE;

	// vfƃXg\
	SetYosoSagyoList();
}

// HXg̒ǉ
void CManualEditDlg::OnButtonKoteiTsuika() 
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];

	// IĂH擾
	int nSelectKotei = nSelectKotei = GetSelectKotei();
	if (nSelectKotei == -1)
		nSelectKotei = cSagyoshaList.aKoteiList.GetSize();

	// VKR[hǉ
	SKoteiList cKoteiList;
	cKoteiList.nIndex = -1;
	cKoteiList.nEditFlag = EDIT_INSERT;
	cKoteiList.bErrorFlag = FALSE;
	cKoteiList.sSubline = g_pDataManager->GetSublineData(cSagyoshaList.nSublineId)->sSublineName;
	cKoteiList.sKoteiKigo = cSagyoshaList.sKoteiKigo;
	cKoteiList.bKyotsuKotei = FALSE;
	cSagyoshaList.aKoteiList.InsertAt(nSelectKotei, cKoteiList);

	// HXg\
	SetKoteiList(nSelectKotei);
}

// vfƌQXg̒ǉ
void CManualEditDlg::OnButtonYosoSagyogunTsuika() 
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	// IĂH擾
	int nSelectKotei = GetSelectKotei();
	if (nSelectKotei == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];
	SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nSelectKotei];

	// IĂvfƌQ擾
	int nSelectYosoSagyogun = GetSelectYosoSagyogun();
	if (nSelectYosoSagyogun == -1)
		nSelectYosoSagyogun = cKoteiList.aYosoSagyogunList.GetSize();

	// VKR[hǉ
	SYosoSagyogunList cYosoSagyogunList;
	cYosoSagyogunList.nIndex = -1;
	cYosoSagyogunList.nEditFlag = EDIT_INSERT;
	cYosoSagyogunList.bErrorFlag = FALSE;
	cYosoSagyogunList.nYosoSagyogunId = -1;
	cYosoSagyogunList.bKyotsuKotei = FALSE;
	cKoteiList.aYosoSagyogunList.InsertAt(nSelectYosoSagyogun, cYosoSagyogunList);

	// vfƌQXg\
	SetYosoSagyogunList(nSelectYosoSagyogun);
}

// vfƃXg̒ǉ
void CManualEditDlg::OnButtonYosoSagyoTsuika() 
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	// IĂH擾
	int nSelectKotei = GetSelectKotei();
	if (nSelectKotei == -1)
		return;

	// IĂvfƌQ擾
	int nSelectYosoSagyogun = GetSelectYosoSagyogun();
	if (nSelectYosoSagyogun == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];
	SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nSelectKotei];
	SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nSelectYosoSagyogun];

	// IĂvfƎ擾
	int nSelectYosoSagyo = GetSelectYosoSagyo();
	if (nSelectYosoSagyo == -1)
		nSelectYosoSagyo = cYosoSagyogunList.aYosoSagyoList.GetSize();

	// VKR[hǉ
	SYosoSagyoList cYosoSagyoList;
	cYosoSagyoList.nIndex = -1;
	cYosoSagyoList.nEditFlag = EDIT_INSERT;
	cYosoSagyoList.bErrorFlag = FALSE;
// --Add 2007/02/26 aizawa sD-187
	cYosoSagyoList.nSagyoNo = (nSelectYosoSagyo == 0) ? 0 : cYosoSagyogunList.aYosoSagyoList[nSelectYosoSagyo - 1].nSagyoNo;
// --Add
	cYosoSagyoList.nYosoSagyoId = -1;
	cYosoSagyoList.bM = FALSE;
	cYosoSagyoList.bN = FALSE;
	cYosoSagyoList.bHassexxxndo = FALSE;
	cYosoSagyoList.bKurikaeshiKaisu = FALSE;
	cYosoSagyoList.bKijunKotei = FALSE;
	cYosoSagyogunList.aYosoSagyoList.InsertAt(nSelectYosoSagyo, cYosoSagyoList);

	// vfƃXg\
	SetYosoSagyoList(nSelectYosoSagyo);
}

// XgRg[ύX
LRESULT CManualEditDlg::OnChangeEdit(WPARAM wp, LPARAM lp)
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)wp;
	LV_ITEM		 *plvItem = &pDispInfo->item;

	int nRow = plvItem->iItem;
	int nCol = plvItem->iSubItem;

	if (pDispInfo->hdr.hwndFrom == m_cListKotei.m_hWnd)
		EditKotei(nRow, nCol);
	else if (pDispInfo->hdr.hwndFrom == m_cListYosoSagyogun.m_hWnd)
		EditYosoSagyogun(nRow, nCol);
	else if (pDispInfo->hdr.hwndFrom == m_cListYosoSagyo.m_hWnd)
		EditYosoSagyo(nRow, nCol);

// Modify ... ( ADD )
	m_bCloseLock = 0;
// By Y.Itabashi (xxxxx) 2007.03.05

	return TRUE;
}

// HXgύX
void CManualEditDlg::EditKotei(int nRow, int nCol)
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];
	SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[m_cListKotei.GetItemRowData(nRow)];

	// ύXꂽf[^擾
	switch (nCol) {
	case COL_KOTEI_BANGO:
		m_cListKotei.GetValue(nRow, nCol, cKoteiList.sKoteiNo);
		break;
	case COL_KOTEI_NAME:
		m_cListKotei.GetValue(nRow, nCol, cKoteiList.sKoteiName);
		break;
	case COL_KOTEI_JIDOU:
		m_cListKotei.GetValue(nRow, nCol, cKoteiList.sJidoShudo);
		SetYosoSagyoList();
		EnableYosoSagyoTsuikaSakujo();
		break;
	}
}

// vfƌQXgύX
void CManualEditDlg::EditYosoSagyogun(int nRow, int nCol)
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	// IĂH擾
	int nSelectKotei = GetSelectKotei();
	if (nSelectKotei == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];
	SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nSelectKotei];
	SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[m_cListYosoSagyogun.GetItemRowData(nRow)];

	// ύXꂽf[^擾
	switch (nCol) {
	case COL_YOSOSAGYOGUN_NAME:
		m_cListYosoSagyogun.GetValue(nRow, nCol, cYosoSagyogunList.sYosoSagyogunName);
		break;
	}
}

// vfƃXgύX
void CManualEditDlg::EditYosoSagyo(int nRow, int nCol)
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	// IĂH擾
	int nSelectKotei = GetSelectKotei();
	if (nSelectKotei == -1)
		return;

	// IĂvfƌQ擾
	int nSelectYosoSagyogun = GetSelectYosoSagyogun();
	if (nSelectYosoSagyogun == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];
	SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nSelectKotei];
	SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nSelectYosoSagyogun];
	SYosoSagyoList &cYosoSagyoList = cYosoSagyogunList.aYosoSagyoList[m_cListYosoSagyo.GetItemRowData(nRow)];
	CString sKijunKotei;

	// ύXꂽf[^擾
	switch (nCol) {
	case COL_YOSOSAGYO_YOSOSAGYO:
		m_cListYosoSagyo.GetValue(nRow, nCol, cYosoSagyoList.sYosoSagyoName);
		break;
	case COL_YOSOSAGYO_YOSOSAGYONO:
		m_cListYosoSagyo.GetValue(nRow, nCol, cYosoSagyoList.sYosoSagyoNo);
		SetYosoSagyoTemplate(cYosoSagyoList);
		break;
	case COL_YOSOSAGYO_M:
		m_cListYosoSagyo.GetValue(nRow, nCol, cYosoSagyoList.fM);
		cYosoSagyoList.bM = TRUE;
		break;
	case COL_YOSOSAGYO_N:
		m_cListYosoSagyo.GetValue(nRow, nCol, cYosoSagyoList.fN);
		cYosoSagyoList.bN = TRUE;
		break;
	case COL_YOSOSAGYO_HINDO:
		m_cListYosoSagyo.GetValue(nRow, nCol, cYosoSagyoList.nHassexxxndo);
		cYosoSagyoList.bHassexxxndo = TRUE;
		break;
	case COL_YOSOSAGYO_KURIKAESI:
		m_cListYosoSagyo.GetValue(nRow, nCol, cYosoSagyoList.nKurikaeshiKaisu);
		cYosoSagyoList.bKurikaeshiKaisu = TRUE;
		break;
	case COL_YOSOSAGYO_KOTEI:
		m_cListYosoSagyo.GetValue(nRow, nCol, cYosoSagyoList.sKoteibuHendobu);
		break;
	case COL_YOSOSAGYO_KIJUN:
		m_cListYosoSagyo.GetValue(nRow, nCol, sKijunKotei);
		cYosoSagyoList.nKijunKotei = (sKijunKotei == g_pSystem->m_cMenuDisp.GetMenu(Menu_ManualEditDlg[37].MenuNo, Menu_ManualEditDlg[37].ItemNo)) ? 1 : 2;
		cYosoSagyoList.bKijunKotei = TRUE;
		break;
	}
}

// vfƃev[gf[^ݒ
void CManualEditDlg::SetYosoSagyoTemplate(SYosoSagyoList &cYosoSagyoList)
{
	SYosoSagyoTemplate *pYosoSagyoTemplate = g_pDataManager->GetYosoSagyoTemplateData(cYosoSagyoList.sYosoSagyoNo);
	if (pYosoSagyoTemplate != NULL) {
		// vfƃev[gf[^ݒ
// Modify ... ( ADD )
		cYosoSagyoList.sYosoSagyoName = pYosoSagyoTemplate->sSagyoNaiyo;
// By Y.Itabashi (xxxxx) 2007.02.16
		cYosoSagyoList.sEnzanShiki = pYosoSagyoTemplate->sEnzanShiki;
		cYosoSagyoList.fS1 = pYosoSagyoTemplate->fS1;
		cYosoSagyoList.fS2 = pYosoSagyoTemplate->fS2;
		cYosoSagyoList.fM = pYosoSagyoTemplate->fM;
		cYosoSagyoList.bM = TRUE;
		cYosoSagyoList.fN = pYosoSagyoTemplate->fN;
		cYosoSagyoList.bN = TRUE;
//		cYosoSagyoList.nHassexxxndo = pYosoSagyoTemplate->nHassexxxndo;
//		cYosoSagyoList.bHassexxxndo = TRUE;
//		cYosoSagyoList.nKurikaeshiKaisu = pYosoSagyoTemplate->nKurikaeshiKaisu;
//		cYosoSagyoList.bKurikaeshiKaisu = TRUE;
		cYosoSagyoList.sSagyoFlag = pYosoSagyoTemplate->sSagyoFlag;

		// vfƃXg\
		SetYosoSagyoList();
	}
}

// Xgr[̃R{{bNX쐬
LRESULT CManualEditDlg::CreateComboList(WPARAM wp, LPARAM lp)
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)wp;

	int nRow = pNMListView->iItem;
	int nCol = pNMListView->iSubItem;

	CStringList	lstGroupNo;
	CString sValue;
	int i;
	int nIndex = 0;
	int nSize;

	switch( pNMListView->hdr.idFrom ){
	case IDC_LIST_KOTEI:
		m_cListKotei.GetValue( nRow, nCol, sValue );
		for (i = 0; i < 3; i++) {
			CString str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualEditDlg[32+i].MenuNo, Menu_ManualEditDlg[32+i].ItemNo );
			lstGroupNo.AddTail( str );
			if( str.Compare( sValue ) == 0 )
				nIndex = i;
		}
		m_cListKotei.SetComboList( nRow, nCol, lstGroupNo, nIndex );
		break;

	case IDC_LIST_YOSO_SAGYO:
		switch( nCol ){
		case COL_YOSOSAGYO_YOSOSAGYONO:
			m_cListYosoSagyo.GetValue( nRow, nCol, sValue );
			nSize = g_pDataManager->GetYosoSagyoTemplateNum();
			for (i = 0; i < nSize; i++) {
				SYosoSagyoTemplate *pYosoSagyoTemplate = g_pDataManager->GetYosoSagyoTemplateData(i);
				lstGroupNo.AddTail( pYosoSagyoTemplate->sYosoSagyoNo );
				if(sValue == pYosoSagyoTemplate->sYosoSagyoNo )
					nIndex = i;
			}
			m_cListYosoSagyo.SetComboList( nRow, nCol, lstGroupNo, nIndex );
			break;

		case COL_YOSOSAGYO_KOTEI:
			m_cListYosoSagyo.GetValue( nRow, nCol, sValue );
			for (i = 0; i < 2; i++) {
				CString str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualEditDlg[35+i].MenuNo, Menu_ManualEditDlg[35+i].ItemNo );
				lstGroupNo.AddTail( str );
				if( str.Compare( sValue ) == 0 )
					nIndex = i;
			}
			m_cListYosoSagyo.SetComboList( nRow, nCol, lstGroupNo, nIndex );
			break;

		case COL_YOSOSAGYO_KIJUN:
			m_cListYosoSagyo.GetValue( nRow, nCol, sValue );
			for (i = 0; i < 2; i++) {
				CString str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualEditDlg[37+i].MenuNo, Menu_ManualEditDlg[37+i].ItemNo );
				lstGroupNo.AddTail( str );
				if( str.Compare( sValue ) == 0 )
					nIndex = i;
			}
			m_cListYosoSagyo.SetComboList( nRow, nCol, lstGroupNo, nIndex );
			break;

		}
		break;

	default:
		break;
	}

	return TRUE;
}

// Xgr[̃R{{bNX̑IύX
LRESULT CManualEditDlg::OnChangeCombo(WPARAM wp, LPARAM lp)
{
	LV_DISPINFO *dispinfo = (LV_DISPINFO*)wp;

	int nRow = dispinfo->item.iItem;
	int nCol = dispinfo->item.iSubItem;
	
	CString sValue;
	if (dispinfo->hdr.hwndFrom == m_cListKotei.m_hWnd) {
		m_cListKotei.SetValue(nRow, nCol, dispinfo->item.pszText);
		EditKotei(nRow, nCol);
	} else if (dispinfo->hdr.hwndFrom == m_cListYosoSagyo.m_hWnd) {
		m_cListYosoSagyo.SetValue(nRow, nCol, dispinfo->item.pszText);
		EditYosoSagyo(nRow, nCol);
	}

	return TRUE;
}

// EHR[h𕶎ɕϊ
CString CManualEditDlg::GetKijunKoteiString(int nKijunKotei)
{
	switch (nKijunKotei) {
	case 1:
		return g_pConst->m_sKijun;
	case 2:
		return g_pConst->m_sKotei;
	}
	return "";
}

// Ǝ҃Xg쐬
void CManualEditDlg::MakeSagyoshaList()
{
	// Ǝ҂ɂ郋[v
	int nSublineNum = g_pDataManager->GetSublineNum();
	for (int nSublineId = 0; nSublineId < nSublineNum; nSublineId++) {
		SSubline *pSubline = g_pDataManager->GetSublineData(nSublineId);

		if (pSubline->bManualEditFlag) {
			// Ǝ҃f[^ݒ
			int nSagyoshNum = g_pDataManager->GetSagyoshaNum(nSublineId);
			for (int nSagyoshId = 0; nSagyoshId < nSagyoshNum; nSagyoshId++) {
				SSagyoshaList *pSagyoshaList = m_aSagyoshaList.AddElement();
				pSagyoshaList->nSublineId = nSublineId;
				pSagyoshaList->nSagyoshaId = nSagyoshId;
				pSagyoshaList->sSagyoshaName = g_pDataManager->GetSagyoshaName(nSublineId, nSagyoshId);
				pSagyoshaList->sKoteiKigo = pSubline->aYosoSagyogun[0].sKoteiKigo;

				// HXg쐬
				MakeKoteiList(nSublineId, nSagyoshId, pSagyoshaList->aKoteiList);
			}
		}
	}

	// ύXӏ`FbN邽߁Af[^ۑĂ
	m_aSagyoshaList2 = m_aSagyoshaList;
}

// HXg쐬
void CManualEditDlg::MakeKoteiList(int nSublineId, int nSagyoshId, CKoteiListArray &aKoteiList)
{
	SSubline *pSubline = g_pDataManager->GetSublineData(nSublineId);
	int nIndex;

	// Ǝ҂̗vfƌQ擾
	CIntArrayEx aYosoSagyogunId;
	g_pDataManager->FindSagyoWariate(nSublineId, nSagyoshId, m_nKishuId, aYosoSagyogunId);

	// vfƌQH擾
	int nSize = aYosoSagyogunId.GetSize();
	for (int i = 0; i < nSize; i++) {
		int nYosoSagyogunId = aYosoSagyogunId[i];
		SYosoSagyogun &cYosoSagyogun = pSubline->aYosoSagyogun[nYosoSagyogunId];

		SKoteiList *pKoteiList = aKoteiList.LookupElement(cYosoSagyogun.sKoteiName);
		if (pKoteiList == NULL) {
			pKoteiList = aKoteiList.AddElement(cYosoSagyogun.sKoteiName, nIndex);
			pKoteiList->nIndex = nIndex;
			pKoteiList->nEditFlag = EDIT_NONE;
			pKoteiList->bErrorFlag = FALSE;
			pKoteiList->sSubline = pSubline->sSublineName;
			pKoteiList->sKoteiKigo = cYosoSagyogun.sKoteiKigo;
			pKoteiList->sKoteiNo = cYosoSagyogun.sKoteiNo;
			pKoteiList->sKoteiName = cYosoSagyogun.sKoteiName;
			pKoteiList->sJidoShudo = cYosoSagyogun.sJidoKotei;
			pKoteiList->bKyotsuKotei = FALSE;
		}
		pKoteiList->bKyotsuKotei |= cYosoSagyogun.aKishuSagyo[m_nKishuId].bKyotsuKotei;

		// vfƌQXg쐬
		MakeYosoSagyogunList(nYosoSagyogunId, cYosoSagyogun, pKoteiList->aYosoSagyogunList);
	}
}

// vfƌQXg쐬
void CManualEditDlg::MakeYosoSagyogunList(int nYosoSagyogunId, SYosoSagyogun &cYosoSagyogun, CYosoSagyogunListArray &aYosoSagyogunList)
{
	int nIndex;

	SYosoSagyogunList *pYosoSagyogunList = aYosoSagyogunList.AddElement(nIndex);
	pYosoSagyogunList->nIndex = nIndex;
	pYosoSagyogunList->nEditFlag = EDIT_NONE;
	pYosoSagyogunList->bErrorFlag = FALSE;
	pYosoSagyogunList->nYosoSagyogunId = nYosoSagyogunId;
	pYosoSagyogunList->sYosoSagyogunName = cYosoSagyogun.sYosoSagyogunName;
	pYosoSagyogunList->bKyotsuKotei = cYosoSagyogun.aKishuSagyo[m_nKishuId].bKyotsuKotei;

	// vfƃXg쐬
	MakeYosoSagyoList(cYosoSagyogun, pYosoSagyogunList->aYosoSagyoList);
}

// vfƃXg쐬
void CManualEditDlg::MakeYosoSagyoList(SYosoSagyogun &cYosoSagyogun, CYosoSagyoListArray &aYosoSagyoList)
{
	int nIndex;

	int nSize = cYosoSagyogun.aYosoSagyo.GetSize();
	for (int nYosoSagyoId = 0; nYosoSagyoId < nSize; nYosoSagyoId++) {
		SYosoSagyo &cYosoSagyo = cYosoSagyogun.aYosoSagyo[nYosoSagyoId];

		if (cYosoSagyo.sDeleteFlag.IsEmpty()) {
			SYosoSagyoList *pYosoSagyoList = aYosoSagyoList.AddElement(nIndex);
			pYosoSagyoList->nIndex = nIndex;
			pYosoSagyoList->nEditFlag = EDIT_NONE;
			pYosoSagyoList->bErrorFlag = FALSE;
			pYosoSagyoList->nYosoSagyoId = nYosoSagyoId;
			pYosoSagyoList->sYosoSagyoName = cYosoSagyo.sYosoSagyoName;
			pYosoSagyoList->sYosoSagyoNo = cYosoSagyo.sYosoSagyoNo;
// --Add 2007/02/26 aizawa sD-187
			pYosoSagyoList->nSagyoNo = cYosoSagyo.nSagyoNo;
// --Add
			pYosoSagyoList->sEnzanShiki = cYosoSagyo.sEnzanShiki;
			pYosoSagyoList->fS1 = cYosoSagyo.fS1;
			pYosoSagyoList->fS2 = cYosoSagyo.fS2;
			pYosoSagyoList->fM = cYosoSagyo.fM;
			pYosoSagyoList->bM = TRUE;
			pYosoSagyoList->fN = cYosoSagyo.fN;
			pYosoSagyoList->bN = TRUE;
			pYosoSagyoList->nHassexxxndo = cYosoSagyo.nHassexxxndo;
			pYosoSagyoList->bHassexxxndo = TRUE;
			pYosoSagyoList->nKurikaeshiKaisu = cYosoSagyo.nKurikaeshiKaisu;
			pYosoSagyoList->bKurikaeshiKaisu = TRUE;
			pYosoSagyoList->sKoteibuHendobu = cYosoSagyo.sKoteibuHendobu;
			pYosoSagyoList->sSagyoFlag = cYosoSagyo.sSagyoFlag;
			pYosoSagyoList->nKijunKotei = cYosoSagyo.nKijunKotei;
			pYosoSagyoList->bKijunKotei = TRUE;
		}
	}
}

// IĂƎ҂擾
int CManualEditDlg::GetSelectSagyosha()
{
	int nIndex = m_cComboSagyosha.GetCurSel();
	if (nIndex == -1)
		return -1;

	return m_cComboSagyosha.GetItemData(nIndex);
}

// IĂH擾
int CManualEditDlg::GetSelectKotei()
{
	POSITION pos = m_cListKotei.GetFirstSelectedItemPosition();
	int nRow = m_cListKotei.GetNextSelectedItem(pos);
	if (nRow < 0)
		return -1;

	return m_cListKotei.GetItemRowData(nRow);
}

// IĂvfƌQ擾
int CManualEditDlg::GetSelectYosoSagyogun()
{
	POSITION pos = m_cListYosoSagyogun.GetFirstSelectedItemPosition();
	int nRow = m_cListYosoSagyogun.GetNextSelectedItem(pos);
	if (nRow < 0)
		return -1;

	return m_cListYosoSagyogun.GetItemRowData(nRow);
}

// IĂvfƂ擾
int CManualEditDlg::GetSelectYosoSagyo()
{
	POSITION pos = m_cListYosoSagyo.GetFirstSelectedItemPosition();
	int nRow = m_cListYosoSagyo.GetNextSelectedItem(pos);
	if (nRow < 0)
		return -1;

	return m_cListYosoSagyo.GetItemRowData(nRow);
}

// vfƂ̒ǉE폜{^̗LEݒ
void CManualEditDlg::EnableYosoSagyoTsuikaSakujo()
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;

	// IĂH擾
	int nSelectKotei = GetSelectKotei();
	if (nSelectKotei == -1)
		return;

	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];
	SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nSelectKotei];

	if (cKoteiList.sJidoShudo == g_pConst->m_sJido) {
		// ǉE폜{^𖳌
		m_cButtonYosoSagyoSakujo.EnableWindow(FALSE);
		m_cButtonYosoSagyoTsuika.EnableWindow(FALSE);
		return;
	} else {
		// ǉE폜{^L
		m_cButtonYosoSagyoSakujo.EnableWindow(TRUE);
		m_cButtonYosoSagyoTsuika.EnableWindow(TRUE);
	}
}

// OK{^NbN
void CManualEditDlg::OnOK() 
{
	// ̓f[^`FbN
	if (!CheckData())
		return;

	CWaitCursor cWaitCursor;

	// ύX
	ChangeData();

	// 폜
	DeleteData();

	// ǉ
	InsertData();

// --Add 2007/02/26 aizawa sD-187
	// Noio
	g_pDataManager->RenumberSagyoNo();
// --Add
	
	CDialogEx::OnOK();
}

// LZ{^NbN
void CManualEditDlg::OnCancel() 
{
// Modify ... ( ADD )
	if( m_bCloseLock )
		return;
// By Y.Itabashi (xxxxx) 2007.03.05

	CDialogEx::OnCancel();
}

// vr[{^NbN
void CManualEditDlg::OnButtonPreview() 
{
	// IĂƎҎ擾
	int nSelectSagyosha = GetSelectSagyosha();
	if (nSelectSagyosha == -1)
		return;
	SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSelectSagyosha];

	// ̓f[^`FbN
	if (!CheckData())
		return;

	CWaitCursor cWaitCursor;

	// Xgf[^ۑ
	CSagyoshaListArray aSagyoshaList;
	aSagyoshaList = m_aSagyoshaList;

	// ύX
	ChangeData();

	// 폜
	DeleteData();

	// ǉ
	InsertData();

// --Add 2007/02/26 aizawa sD-187
	// Noio
	g_pDataManager->RenumberSagyoNo();
// --Add

	// 蓮ҐʂXV
	m_pDoc->DispCenterSagyosha(cSagyoshaList.nSublineId, cSagyoshaList.nSagyoshaId);

	// Xgf[^𕜌
	g_pDataManager->RestoreUndoData();
	m_aSagyoshaList = aSagyoshaList;
}

// w肵Xg\
void CManualEditDlg::DispList(int nSagyoshaIndex, int nKoteiIndex, int nYosoSagyogunIndex)
{
	int i;
	int nCount;

	// Ǝ҂\
	nCount = m_cComboSagyosha.GetCount();
	for (i = 0; i < nCount; i++) {
		if ((int)m_cComboSagyosha.GetItemData(i) == nSagyoshaIndex) {
			m_cComboSagyosha.SetCurSel(i);
			SetKoteiList();
			break;
		}
	}

	// H\
	if (nKoteiIndex != -1) {
		nCount = m_cListKotei.GetItemCount();
		for (i = 0; i < nCount; i++) {
			if ((int)m_cListKotei.GetItemRowData(i) == nKoteiIndex) {
				m_cListKotei.SelectChange(i);
				break;
			}
		}
	}

	// vfƌQ\
	if (nYosoSagyogunIndex != -1) {
		nCount = m_cListYosoSagyogun.GetItemCount();
		for (i = 0; i < nCount; i++) {
			if ((int)m_cListYosoSagyogun.GetItemRowData(i) == nYosoSagyogunIndex) {
				m_cListYosoSagyogun.SelectChange(i);
				break;
			}
		}
	}
}

// ̓f[^`FbN
BOOL CManualEditDlg::CheckData()
{
	// G[tONA
	ClearErrorFlag();

	// ύXtOZbg
	SetChangeFlag();

	// ̓`FbN
	if (!CheckMinyuryoku())
		return FALSE;

	// ̓f[^L`FbN
	if (!CheckInputData())
		return FALSE;

	// H݃`FbN
	if (!CheckSameKotei())
		return FALSE;

	// vfƌQ݃`FbN
	if (!CheckSameYosoSagyogun())
		return FALSE;

	// vfƌQ݃`FbN
	if (!CheckYosoSagyogun())
		return FALSE;

	// vfƑ݃`FbN
	if (!CheckYosoSagyo())
		return FALSE;

	// ʍHҏW`FbN
	if (!CheckKyotsuKotei())
		return FALSE;

	return TRUE;
}

// G[tONA
void CManualEditDlg::ClearErrorFlag()
{
	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];

			// HG[tONA
			cKoteiList.bErrorFlag = FALSE;

			// vfƌQXgɂ郋[v
			int nYosoSagyogunNum = cKoteiList.aYosoSagyogunList.GetSize();
			for (int nYosoSagyogunIndex = 0; nYosoSagyogunIndex < nYosoSagyogunNum; nYosoSagyogunIndex++) {
				SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nYosoSagyogunIndex];

				// vfƌQG[tONA
				cYosoSagyogunList.bErrorFlag = FALSE;

				// vfƃXgɂ郋[v
				int nYosoSagyoNum = cYosoSagyogunList.aYosoSagyoList.GetSize();
				for (int nYosoSagyoIndex = 0; nYosoSagyoIndex < nYosoSagyoNum; nYosoSagyoIndex++) {
					SYosoSagyoList &cYosoSagyoList = cYosoSagyogunList.aYosoSagyoList[nYosoSagyoIndex];

					// vfƃG[tONA
					cYosoSagyoList.bErrorFlag = FALSE;
				}
			}
		}
	}
}

// ύXtOZbg
void CManualEditDlg::SetChangeFlag()
{
	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];
		SSagyoshaList &cSagyoshaList2 = m_aSagyoshaList2[nSagyoshaIndex];

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];
			if (cKoteiList.nIndex != -1 && cKoteiList.nEditFlag != EDIT_DELETE) {
				SKoteiList &cKoteiList2 = cSagyoshaList2.aKoteiList[cKoteiList.nIndex];

				// Ȟf[^Ɠ̓f[^r
				if (cKoteiList.sKoteiNo != cKoteiList2.sKoteiNo ||
						cKoteiList.sKoteiName != cKoteiList2.sKoteiName ||
						cKoteiList.sJidoShudo != cKoteiList2.sJidoShudo)
					cKoteiList.nEditFlag = EDIT_CHANGE;
				else
					cKoteiList.nEditFlag = EDIT_NONE;

				// vfƌQXgɂ郋[v
				int nYosoSagyogunNum = cKoteiList.aYosoSagyogunList.GetSize();
				for (int nYosoSagyogunIndex = 0; nYosoSagyogunIndex < nYosoSagyogunNum; nYosoSagyogunIndex++) {
					SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nYosoSagyogunIndex];
					if (cYosoSagyogunList.nIndex != -1 && cYosoSagyogunList.nEditFlag != EDIT_DELETE) {
						SYosoSagyogunList &cYosoSagyogunList2 = cKoteiList2.aYosoSagyogunList[cYosoSagyogunList.nIndex];

						// vfƌQ̌f[^Ɠ̓f[^r
						if (cYosoSagyogunList.sYosoSagyogunName != cYosoSagyogunList2.sYosoSagyogunName)
							cYosoSagyogunList.nEditFlag = EDIT_CHANGE;
						else
							cYosoSagyogunList.nEditFlag = EDIT_NONE;

						// vfƃXgɂ郋[v
						int nYosoSagyoNum = cYosoSagyogunList.aYosoSagyoList.GetSize();
						for (int nYosoSagyoIndex = 0; nYosoSagyoIndex < nYosoSagyoNum; nYosoSagyoIndex++) {
							SYosoSagyoList &cYosoSagyoList = cYosoSagyogunList.aYosoSagyoList[nYosoSagyoIndex];
							if (cYosoSagyoList.nIndex != -1 && cYosoSagyoList.nEditFlag != EDIT_DELETE) {
								SYosoSagyoList &cYosoSagyoList2 = cYosoSagyogunList2.aYosoSagyoList[cYosoSagyoList.nIndex];

								// vfƂ̌f[^Ɠ̓f[^r
								if (cYosoSagyoList.sYosoSagyoName != cYosoSagyoList2.sYosoSagyoName ||
										cYosoSagyoList.sYosoSagyoNo !=  cYosoSagyoList2.sYosoSagyoNo ||
										cYosoSagyoList.fM != cYosoSagyoList2.fM ||
										cYosoSagyoList.fN != cYosoSagyoList2.fN ||
										cYosoSagyoList.nHassexxxndo != cYosoSagyoList2.nHassexxxndo ||
										cYosoSagyoList.nKurikaeshiKaisu != cYosoSagyoList2.nKurikaeshiKaisu ||
										cYosoSagyoList.sKoteibuHendobu != cYosoSagyoList2.sKoteibuHendobu ||
										cYosoSagyoList.nKijunKotei != cYosoSagyoList2.nKijunKotei)
									cYosoSagyoList.nEditFlag = EDIT_CHANGE;
								else
									cYosoSagyoList.nEditFlag = EDIT_NONE;
							}
						}
					}
				}
			}
		}
	}
}

// ̓`FbN
BOOL CManualEditDlg::CheckMinyuryoku()
{
	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];

			if (cKoteiList.nEditFlag != EDIT_DELETE) {
				if (cKoteiList.nEditFlag != EDIT_NONE) {
					if (cKoteiList.sKoteiNo.IsEmpty() || cKoteiList.sKoteiName.IsEmpty() || cKoteiList.sJidoShudo.IsEmpty()) {
						cKoteiList.bErrorFlag = TRUE;
						DispList(nSagyoshaIndex);
						g_pSystem->DispMessage("E014001");
						return FALSE;
					}
				}

				// vfƌQXgɂ郋[v
				int nYosoSagyogunNum = cKoteiList.aYosoSagyogunList.GetSize();
				for (int nYosoSagyogunIndex = 0; nYosoSagyogunIndex < nYosoSagyogunNum; nYosoSagyogunIndex++) {
					SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nYosoSagyogunIndex];

					if (cYosoSagyogunList.nEditFlag != EDIT_DELETE) {
						if (cYosoSagyogunList.nEditFlag != EDIT_NONE) {
							if (cYosoSagyogunList.sYosoSagyogunName.IsEmpty()) {
								cYosoSagyogunList.bErrorFlag = TRUE;
								DispList(nSagyoshaIndex, nKoteiIndex);
								g_pSystem->DispMessage("E014001");
								return FALSE;
							}
						}

						// vfƃXgɂ郋[v
						if (cKoteiList.sJidoShudo != g_pConst->m_sJido) {
							int nYosoSagyoNum = cYosoSagyogunList.aYosoSagyoList.GetSize();
							for (int nYosoSagyoIndex = 0; nYosoSagyoIndex < nYosoSagyoNum; nYosoSagyoIndex++) {
								SYosoSagyoList &cYosoSagyoList = cYosoSagyogunList.aYosoSagyoList[nYosoSagyoIndex];

								if (cYosoSagyoList.nEditFlag != EDIT_DELETE && cYosoSagyoList.nEditFlag != EDIT_NONE) {
									if (cYosoSagyoList.sYosoSagyoName.IsEmpty() || cYosoSagyoList.sYosoSagyoNo.IsEmpty() ||
											!cYosoSagyoList.bM || !cYosoSagyoList.bN || !cYosoSagyoList.bHassexxxndo || !cYosoSagyoList.bKurikaeshiKaisu ||
											cYosoSagyoList.sKoteibuHendobu.IsEmpty() || !cYosoSagyoList.bKijunKotei) {
										cYosoSagyoList.bErrorFlag = TRUE;
										DispList(nSagyoshaIndex, nKoteiIndex, nYosoSagyogunIndex);
										g_pSystem->DispMessage("E014001");
										return FALSE;
									}
								}
							}
						}
					}
				}
			}
		}
	}

	return TRUE;
}

// ̓f[^L`FbN
BOOL CManualEditDlg::CheckInputData()
{
	static CDataCheck aKoteiDataCheck[] = {
		{eDataTypeNumber, 32, 0, 0, 0, NULL},
		{eDataTypeKoteiName, 128, 0, 0, 0, NULL},
		{eDataTypeAll, 6, 0, 0, 0, NULL}
	};
	static CDataCheck aYosoSagyogunDataCheck[] = {
		{eDataTypeKoteiName, 128, 0, 0, 0, NULL}
	};
	static CDataCheck aYosoSagyoDataCheck[] = {
		{eDataTypeAll, 128, 0, 0, 0, NULL},
		{eDataTypeNumber, 8, 0, 0, 0, NULL},
		{eDataTypeNumber, 10, 4, -9999.9999, 9999.9999, NULL},
		{eDataTypeNumber, 10, 4, -9999.9999, 9999.9999, NULL},
		{eDataTypeNumber, 4, 0, 1, 9999, NULL},
		{eDataTypeNumber, 4, 0, 0, 9999, NULL},
		{eDataTypeAll, 6, 0, 0, 0, NULL},
		{eDataTypeNumber, 1, 0, 1, 2, NULL}
	};

	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];

			if (cKoteiList.nEditFlag != EDIT_DELETE) {
				if (cKoteiList.nEditFlag != EDIT_NONE) {
					// H̃f[^`FbN
					if (!CheckInputDataSub(aKoteiDataCheck[0], cKoteiList.sKoteiNo) ||
							!CheckInputDataSub(aKoteiDataCheck[1], cKoteiList.sKoteiName) ||
							!CheckInputDataSub(aKoteiDataCheck[2], cKoteiList.sJidoShudo)) {
						cKoteiList.bErrorFlag = TRUE;
						DispList(nSagyoshaIndex);
						g_pSystem->DispMessage("E014002");
						return FALSE;
					}
				}

				// vfƌQXgɂ郋[v
				int nYosoSagyogunNum = cKoteiList.aYosoSagyogunList.GetSize();
				for (int nYosoSagyogunIndex = 0; nYosoSagyogunIndex < nYosoSagyogunNum; nYosoSagyogunIndex++) {
					SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nYosoSagyogunIndex];

					if (cYosoSagyogunList.nEditFlag != EDIT_DELETE) {
						if (cYosoSagyogunList.nEditFlag != EDIT_NONE) {
							// vfƌQ̃f[^`FbN
							if (!CheckInputDataSub(aYosoSagyogunDataCheck[0], cYosoSagyogunList.sYosoSagyogunName)) {
								cYosoSagyogunList.bErrorFlag = TRUE;
								DispList(nSagyoshaIndex, nKoteiIndex);
								g_pSystem->DispMessage("E014002");
								return FALSE;
							}
						}

						// vfƃXgɂ郋[v
						int nYosoSagyoNum = cYosoSagyogunList.aYosoSagyoList.GetSize();
						for (int nYosoSagyoIndex = 0; nYosoSagyoIndex < nYosoSagyoNum; nYosoSagyoIndex++) {
							SYosoSagyoList &cYosoSagyoList = cYosoSagyogunList.aYosoSagyoList[nYosoSagyoIndex];

							if (cYosoSagyoList.nEditFlag != EDIT_DELETE && cYosoSagyoList.nEditFlag != EDIT_NONE) {
								// vfƂ̃f[^`FbN
								if (!CheckInputDataSub(aYosoSagyoDataCheck[0], cYosoSagyoList.sYosoSagyoName) ||
										!CheckInputDataSub(aYosoSagyoDataCheck[1], cYosoSagyoList.sYosoSagyoNo) ||
										!CheckInputDataSub(aYosoSagyoDataCheck[2], cYosoSagyoList.fM) ||
										!CheckInputDataSub(aYosoSagyoDataCheck[3], cYosoSagyoList.fN) ||
										!CheckInputDataSub(aYosoSagyoDataCheck[4], (double)cYosoSagyoList.nHassexxxndo) ||
										!CheckInputDataSub(aYosoSagyoDataCheck[5], (double)cYosoSagyoList.nKurikaeshiKaisu) ||
										!CheckInputDataSub(aYosoSagyoDataCheck[6], cYosoSagyoList.sKoteibuHendobu) ||
										!CheckInputDataSub(aYosoSagyoDataCheck[7], (double)cYosoSagyoList.nKijunKotei)) {
									cYosoSagyoList.bErrorFlag = TRUE;
									DispList(nSagyoshaIndex, nKoteiIndex, nYosoSagyogunIndex);
									g_pSystem->DispMessage("E014002");
									return FALSE;
								}
							}
						}
					}
				}
			}
		}
	}

	return TRUE;
}

// f[^̃`FbN
BOOL CManualEditDlg::CheckInputDataSub(CDataCheck &cDataCheck, LPCTSTR pData)
{
	return cDataCheck.ValidCharCheck(pData) && cDataCheck.LengthCheck(pData);
}

// lf[^̃`FbN
BOOL CManualEditDlg::CheckInputDataSub(CDataCheck &cDataCheck, double fData)
{
	return cDataCheck.RangeCheck(fData);
}

// vfƌQ݃`FbN
BOOL CManualEditDlg::CheckYosoSagyogun()
{
	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];

			if (cKoteiList.nEditFlag != EDIT_DELETE) {
				// vfƌQXgɂ郋[v
				int nYosoSagyogunNum = cKoteiList.aYosoSagyogunList.GetSize();
				for (int nYosoSagyogunIndex = 0; nYosoSagyogunIndex < nYosoSagyogunNum; nYosoSagyogunIndex++) {
					if (cKoteiList.aYosoSagyogunList[nYosoSagyogunIndex].nEditFlag != EDIT_DELETE)
						break;
				}
				if (nYosoSagyogunIndex == nYosoSagyogunNum) {
					// vfƌQ΃G[
					cKoteiList.bErrorFlag = TRUE;
					DispList(nSagyoshaIndex);
					g_pSystem->DispMessage("E014012");
					return FALSE;			
				}
			}
		}
	}

	return TRUE;
}

// vfƑ݃`FbN
BOOL CManualEditDlg::CheckYosoSagyo()
{
	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];

			if (cKoteiList.nEditFlag != EDIT_DELETE) {
				// vfƌQXgɂ郋[v
				int nYosoSagyogunNum = cKoteiList.aYosoSagyogunList.GetSize();
				for (int nYosoSagyogunIndex = 0; nYosoSagyogunIndex < nYosoSagyogunNum; nYosoSagyogunIndex++) {
					SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nYosoSagyogunIndex];

					if (cYosoSagyogunList.nEditFlag != EDIT_DELETE) {
						// vfƃXgɂ郋[v
						if (cKoteiList.sJidoShudo != g_pConst->m_sJido) {
							int nYosoSagyoNum = cYosoSagyogunList.aYosoSagyoList.GetSize();
							for (int nYosoSagyoIndex = 0; nYosoSagyoIndex < nYosoSagyoNum; nYosoSagyoIndex++) {
								if (cYosoSagyogunList.aYosoSagyoList[nYosoSagyoIndex].nEditFlag != EDIT_DELETE)
									break;
							}
							if (nYosoSagyoIndex == nYosoSagyoNum) {
								// vfƂ΃G[
								cYosoSagyogunList.bErrorFlag = TRUE;
								DispList(nSagyoshaIndex, nKoteiIndex);
								g_pSystem->DispMessage("E014013");
								return FALSE;			
							}
						}
					}
				}
			}
		}
	}

	return TRUE;
}

// H݃`FbN
BOOL CManualEditDlg::CheckSameKotei()
{
	CString sKoteiKey;
	CStringArrayEx aKoteiKey;

	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];

		aKoteiKey.RemoveAll();

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];

			if (cKoteiList.nEditFlag != EDIT_DELETE) {
				sKoteiKey = cKoteiList.sKoteiNo + cKoteiList.sKoteiName;
				if (aKoteiKey.Find(sKoteiKey) != -1) {
					// H΃G[
					cKoteiList.bErrorFlag = TRUE;
					DispList(nSagyoshaIndex);
					g_pSystem->DispMessage("E014010");
					return FALSE;			
				} else
					aKoteiKey.Add(sKoteiKey);
			}
		}
	}

	return TRUE;
}

// vfƌQ݃`FbN
BOOL CManualEditDlg::CheckSameYosoSagyogun()
{
	CStringArrayEx aYosoSagyogunName;

	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];

			if (cKoteiList.nEditFlag != EDIT_DELETE) {
				aYosoSagyogunName.RemoveAll();

				// vfƌQXgɂ郋[v
				int nYosoSagyogunNum = cKoteiList.aYosoSagyogunList.GetSize();
				for (int nYosoSagyogunIndex = 0; nYosoSagyogunIndex < nYosoSagyogunNum; nYosoSagyogunIndex++) {
					SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nYosoSagyogunIndex];

					if (cYosoSagyogunList.nEditFlag != EDIT_DELETE) {
						if (aYosoSagyogunName.Find(cYosoSagyogunList.sYosoSagyogunName) != -1) {
							// vfƌQ΃G[
							cYosoSagyogunList.bErrorFlag = TRUE;
							DispList(nSagyoshaIndex, nKoteiIndex);
							g_pSystem->DispMessage("E014011");
							return FALSE;			
						} else
							aYosoSagyogunName.Add(cYosoSagyogunList.sYosoSagyogunName);
					}
				}
			}
		}
	}

	return TRUE;
}

// ʍHύX`FbN
BOOL CManualEditDlg::CheckKyotsuKotei()
{
	CStringArrayEx aKyotsuKoteiEdit;

	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList2.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];

			if (cKoteiList.nEditFlag != EDIT_DELETE) {
				if (cKoteiList.nEditFlag == EDIT_CHANGE && cKoteiList.bKyotsuKotei)
					aKyotsuKoteiEdit.AddUnique(cSagyoshaList.sSagyoshaName + "\t" + cKoteiList.sKoteiName);

				// vfƌQXgɂ郋[v
				int nYosoSagyogunNum = cKoteiList.aYosoSagyogunList.GetSize();
				for (int nYosoSagyogunIndex = 0; nYosoSagyogunIndex < nYosoSagyogunNum; nYosoSagyogunIndex++) {
					SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nYosoSagyogunIndex];

					if (cYosoSagyogunList.nEditFlag != EDIT_DELETE) {
						if (cYosoSagyogunList.nEditFlag == EDIT_CHANGE && cYosoSagyogunList.bKyotsuKotei)
							aKyotsuKoteiEdit.AddUnique(cSagyoshaList.sSagyoshaName + "\t" + cKoteiList.sKoteiName);

						// vfƃXgɂ郋[v
						int nYosoSagyoNum = cYosoSagyogunList.aYosoSagyoList.GetSize();
						for (int nYosoSagyoIndex = 0; nYosoSagyoIndex < nYosoSagyoNum; nYosoSagyoIndex++) {
							SYosoSagyoList &cYosoSagyoList = cYosoSagyogunList.aYosoSagyoList[nYosoSagyoIndex];

							if (cYosoSagyoList.nEditFlag != EDIT_DELETE) {
								if (cYosoSagyoList.nEditFlag == EDIT_CHANGE && cYosoSagyogunList.bKyotsuKotei)
									aKyotsuKoteiEdit.AddUnique(cSagyoshaList.sSagyoshaName + "\t" + cKoteiList.sKoteiName);
							}
						}
					}
				}
			}
		}
	}

	// ʍH̕ύXmFbZ[W\
	CStringArrayEx aSagyoshaKotei;
	int nSize = aKyotsuKoteiEdit.GetSize();
	for (int i = 0; i < nSize; i++) {
		aSagyoshaKotei.Split("\t", aKyotsuKoteiEdit[i]);
		if (g_pSystem->DispMessage("W014009", aSagyoshaKotei[0], aSagyoshaKotei[1]) == IDCANCEL)
			return FALSE;
	}

	return TRUE;
}

// f[^ύX
void CManualEditDlg::ChangeData()
{
	CString sChangeKotei;
	CString sChangeYosoSagyogun;
	CString sChangeYosoSagyo;

	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];
		SSubline *pSubline = g_pDataManager->GetSublineData(cSagyoshaList.nSublineId);

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];

			if (cKoteiList.nEditFlag != EDIT_DELETE && cKoteiList.nEditFlag != EDIT_INSERT) {
				sChangeKotei = (cKoteiList.nEditFlag == EDIT_CHANGE) ? "1" : "";

				// vfƌQXgɂ郋[v
				int nYosoSagyogunNum = cKoteiList.aYosoSagyogunList.GetSize();
				for (int nYosoSagyogunIndex = 0; nYosoSagyogunIndex < nYosoSagyogunNum; nYosoSagyogunIndex++) {
					SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nYosoSagyogunIndex];

					if (cYosoSagyogunList.nEditFlag != EDIT_DELETE && cYosoSagyogunList.nEditFlag != EDIT_INSERT) {
						sChangeYosoSagyogun = (cYosoSagyogunList.nEditFlag == EDIT_CHANGE) ? "2" : sChangeKotei;

						SYosoSagyogun *pYosoSagyogun;
						if (!sChangeYosoSagyogun.IsEmpty()){
							SYosoSagyogun &cYosoSagyogun = pSubline->aYosoSagyogun[cYosoSagyogunList.nYosoSagyogunId];

							// vfƌQVɒǉ
							pYosoSagyogun = pSubline->aYosoSagyogun.AddElement(cKoteiList.sKoteiName + cYosoSagyogunList.sYosoSagyogunName, cYosoSagyogunList.nYosoSagyogunId);
							*pYosoSagyogun = cYosoSagyogun;
							pYosoSagyogun->sKoteiKigo = cKoteiList.sKoteiKigo;
							pYosoSagyogun->sKoteiNo = cKoteiList.sKoteiNo;
							pYosoSagyogun->sKoteiName = ConvertHankaku(cKoteiList.sKoteiName);
							pYosoSagyogun->sYosoSagyogunName = ConvertHankaku(cYosoSagyogunList.sYosoSagyogunName);
							pYosoSagyogun->sJidoYosoSagyogun = cKoteiList.sJidoShudo;
							pYosoSagyogun->sJidoKotei = cKoteiList.sJidoShudo;

							int nYosoSagyoNum = cYosoSagyogun.aYosoSagyo.GetSize();
							for (int i = 0; i < nYosoSagyoNum; i++) {
								// ̗vfƌQɍ폜tOݒ
								cYosoSagyogun.aYosoSagyo[i].sDeleteFlag = sChangeYosoSagyogun;

								// ǉvfƌQɒǉtOݒ
								pYosoSagyogun->aYosoSagyo[i].sInsertFlag = sChangeYosoSagyogun;
							}
						} else
							pYosoSagyogun = &pSubline->aYosoSagyogun[cYosoSagyogunList.nYosoSagyogunId];

						// vfƃXgɂ郋[v
						int nYosoSagyoNum = cYosoSagyogunList.aYosoSagyoList.GetSize();
						for (int nYosoSagyoIndex = 0; nYosoSagyoIndex < nYosoSagyoNum; nYosoSagyoIndex++) {
							SYosoSagyoList &cYosoSagyoList = cYosoSagyogunList.aYosoSagyoList[nYosoSagyoIndex];

							if (cYosoSagyoList.nEditFlag == EDIT_CHANGE) {
								SYosoSagyo &cYosoSagyo = pYosoSagyogun->aYosoSagyo[cYosoSagyoList.nYosoSagyoId];
								SetYosoSagyoData(cYosoSagyo, cYosoSagyoList);
							}
						}
					}
				}
			}
		}
	}
}

// f[^폜
void CManualEditDlg::DeleteData()
{
	CString sDeleteKoteiFlag;
	CString sDeleteYosoSagyogunFlag;

	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];
		SSubline *pSubline = g_pDataManager->GetSublineData(cSagyoshaList.nSublineId);

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];

			if (cKoteiList.nEditFlag != EDIT_INSERT) {
				sDeleteKoteiFlag = (cKoteiList.nEditFlag == EDIT_DELETE) ? "1" : "";

				// vfƌQXgɂ郋[v
				int nYosoSagyogunNum = cKoteiList.aYosoSagyogunList.GetSize();
				for (int nYosoSagyogunIndex = 0; nYosoSagyogunIndex < nYosoSagyogunNum; nYosoSagyogunIndex++) {
					SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nYosoSagyogunIndex];

					if (cYosoSagyogunList.nEditFlag != EDIT_INSERT && cYosoSagyogunList.nYosoSagyogunId != -1) {
						SYosoSagyogun &cYosoSagyogun = pSubline->aYosoSagyogun[cYosoSagyogunList.nYosoSagyogunId];
						sDeleteYosoSagyogunFlag = (sDeleteKoteiFlag.IsEmpty() && cYosoSagyogunList.nEditFlag == EDIT_DELETE) ? "2" : sDeleteKoteiFlag;

						// vfƃXgɂ郋[v
						int nOffset = 0;
						int nYosoSagyoNum = cYosoSagyogunList.aYosoSagyoList.GetSize();
						for (int nYosoSagyoIndex = 0; nYosoSagyoIndex < nYosoSagyoNum; nYosoSagyoIndex++) {
							SYosoSagyoList &cYosoSagyoList = cYosoSagyogunList.aYosoSagyoList[nYosoSagyoIndex];

							if (cYosoSagyoList.nEditFlag != EDIT_INSERT && cYosoSagyoList.nYosoSagyoId != -1) {
								// vfƂ폜
								if (cYosoSagyoList.nEditFlag == EDIT_DELETE) {
									cYosoSagyogun.aYosoSagyo.RemoveAt(cYosoSagyoList.nYosoSagyoId + nOffset);
									nOffset--;
								}

								// H܂͗vfƌQ폜Ăꍇ͍폜tOZbg
								if (!sDeleteYosoSagyogunFlag.IsEmpty()) {
									int nYosoSagyoNum = cYosoSagyogun.aYosoSagyo.GetSize();
									for (int nYosoSagyoIndex = 0; nYosoSagyoIndex < nYosoSagyoNum; nYosoSagyoIndex++)
										cYosoSagyogun.aYosoSagyo[nYosoSagyoIndex].sDeleteFlag = sDeleteYosoSagyogunFlag;
								}
							}
						}
					}
				}
			}
		}
	}
}

// f[^ǉ
void CManualEditDlg::InsertData()
{
	CString sInsertKoteiFlag;
	CString sInsertYosoSagyogunFlag;
	int nKishuNum = g_pDataManager->GetKishuNum();
	int nLastYosoSagyogunId = -1;

	// Ǝ҃Xgɂ郋[v
	int nSagyoshaNum = m_aSagyoshaList.GetSize();
	for (int nSagyoshaIndex = 0; nSagyoshaIndex < nSagyoshaNum; nSagyoshaIndex++) {
		SSagyoshaList &cSagyoshaList = m_aSagyoshaList[nSagyoshaIndex];
		SSubline *pSubline = g_pDataManager->GetSublineData(cSagyoshaList.nSublineId);

		// HXgɂ郋[v
		int nKoteiNum = cSagyoshaList.aKoteiList.GetSize();
		for (int nKoteiIndex = 0; nKoteiIndex < nKoteiNum; nKoteiIndex++) {
			SKoteiList &cKoteiList = cSagyoshaList.aKoteiList[nKoteiIndex];

			if (cKoteiList.nEditFlag != EDIT_DELETE) {
				sInsertKoteiFlag = (cKoteiList.nEditFlag == EDIT_INSERT) ? "1" : "";

				// vfƌQXgɂ郋[v
				int nYosoSagyogunNum = cKoteiList.aYosoSagyogunList.GetSize();
				for (int nYosoSagyogunIndex = 0; nYosoSagyogunIndex < nYosoSagyogunNum; nYosoSagyogunIndex++) {
					SYosoSagyogunList &cYosoSagyogunList = cKoteiList.aYosoSagyogunList[nYosoSagyogunIndex];

					if (cYosoSagyogunList.nEditFlag != EDIT_DELETE) {
						sInsertYosoSagyogunFlag = (sInsertKoteiFlag.IsEmpty() && cYosoSagyogunList.nEditFlag == EDIT_INSERT) ? "2" : sInsertKoteiFlag;

						SYosoSagyogun *pYosoSagyogun;
						if (cYosoSagyogunList.nYosoSagyogunId != -1) {
							pYosoSagyogun = &pSubline->aYosoSagyogun[cYosoSagyogunList.nYosoSagyogunId];
							nLastYosoSagyogunId = cYosoSagyogunList.nYosoSagyogunId;
						} else {
							CSagyojunArray aSagyojun;
							g_pDataManager->GetSagyojun(cSagyoshaList.nSublineId, m_nKishuId, aSagyojun);

							int nSagyojun = 0;
							if (nLastYosoSagyogunId != -1) {
								int nSize = aSagyojun.GetSize();
								for (int i = 0; i < nSize; i++) {
									if (aSagyojun[i].nYosoSagyogunId == nLastYosoSagyogunId) {
										nSagyojun = i + 1;
										break;
									}
								}
							}

							// vfƌQǉ
							int nAddYosoSagyogunId;
							pYosoSagyogun = pSubline->aYosoSagyogun.AddElement(cKoteiList.sKoteiName + cYosoSagyogunList.sYosoSagyogunName, nAddYosoSagyogunId);
							pYosoSagyogun->sKoteiKigo = cKoteiList.sKoteiKigo;
							pYosoSagyogun->sKoteiNo = cKoteiList.sKoteiNo;
							pYosoSagyogun->sKoteiName = ConvertHankaku(cKoteiList.sKoteiName);
							pYosoSagyogun->sYosoSagyogunName = ConvertHankaku(cYosoSagyogunList.sYosoSagyogunName);
							pYosoSagyogun->sJidoYosoSagyogun = cKoteiList.sJidoShudo;
							pYosoSagyogun->sJidoKotei = cKoteiList.sJidoShudo;
							pYosoSagyogun->aKishuSagyo.SetSize(nKishuNum);
// Modify ... ( ADD )
							// HKᔽt@Co͗pf[^쐬
							SKatashikiError cKatashikiError;
							SLineError cLineError;

							cKatashikiError.nKishuID = m_nKishuId;
							cKatashikiError.sSublineFrom = pSubline->sSublineName;
							cKatashikiError.sKoteiNoFrom = cKoteiList.sKoteiNo;
							cKatashikiError.sKoteiNameFrom = ConvertHankaku(cKoteiList.sKoteiName);
							cKatashikiError.sYosoSagyogunNameFrom = ConvertHankaku(cYosoSagyogunList.sYosoSagyogunName);
							cKatashikiError.sRiyuNo = "E014014";

							cLineError.nKishuID = m_nKishuId;
							cLineError.sSublineFrom = pSubline->sSublineName;
							cLineError.sKoteiNoFrom = cKoteiList.sKoteiNo;
							cLineError.sKoteiNameFrom = ConvertHankaku(cKoteiList.sKoteiName);
							cLineError.sYosoSagyogunNameFrom = ConvertHankaku(cYosoSagyogunList.sYosoSagyogunName);
							cLineError.sRiyuNo = "E014014";

							g_pDataManager->AddKojunKiseiError( cKatashikiError, cLineError );
// By Y.Itabashi (xxxxx) 2007.02.19

							// @ʃf[^ݒ
							SKishuSagyo &cKishuSagyo = pYosoSagyogun->aKishuSagyo[m_nKishuId];
							cKishuSagyo.nSagyojun = 1;
							cKishuSagyo.nSagyoshaId = cSagyoshaList.nSagyoshaId;
							cKishuSagyo.nGroupNo = g_pDataManager->GetNewGroupNo(cSagyoshaList.nSublineId);
							cKishuSagyo.bKyotsuKotei = FALSE;
							cKishuSagyo.bNewMove = FALSE;

							// Əݒ
							SSagyojun cSagyojun;
							cSagyojun.nYosoSagyogunId = nAddYosoSagyogunId;
							cSagyojun.nKishuId = m_nKishuId;
							aSagyojun.InsertAt(nSagyojun, cSagyojun);
							g_pDataManager->OrderBySagyojun(cSagyoshaList.nSublineId, aSagyojun);

							nLastYosoSagyogunId = nAddYosoSagyogunId;
						}

						// vfƃXgɂ郋[v
						int nOffset = 0;
						int nInsertYosoSagyoId = 0;
						int nYosoSagyoNum = cYosoSagyogunList.aYosoSagyoList.GetSize();
						for (int nYosoSagyoIndex = 0; nYosoSagyoIndex < nYosoSagyoNum; nYosoSagyoIndex++) {
							SYosoSagyoList &cYosoSagyoList = cYosoSagyogunList.aYosoSagyoList[nYosoSagyoIndex];

							if (cYosoSagyoList.nEditFlag == EDIT_INSERT) {
								// vfƂǉ
								SYosoSagyo cYosoSagyo;
								cYosoSagyo.sYosoSagyoNo = cYosoSagyoList.sYosoSagyoNo;
								cYosoSagyo.nSagyoNo = 0;
								if (!sInsertYosoSagyogunFlag.IsEmpty())
									cYosoSagyo.sInsertFlag = sInsertYosoSagyogunFlag;
								cYosoSagyo.nRow = g_pDataManager->AddYosoSagyoHyo();
								SetYosoSagyoData(cYosoSagyo, cYosoSagyoList);

								pYosoSagyogun->aYosoSagyo.InsertAt(nInsertYosoSagyoId++, cYosoSagyo);

								nOffset++;
							} else {
								if (cYosoSagyoList.nEditFlag == EDIT_DELETE)
									nOffset--;

								if (cYosoSagyoList.nYosoSagyoId != -1)
									nInsertYosoSagyoId = cYosoSagyoList.nYosoSagyoId + nOffset + 1;
							}
						}

						// HŗvfƂꍇ͂Pǉ
						if (cKoteiList.sJidoShudo == g_pConst->m_sJido && nYosoSagyoNum == 0) {
							SYosoSagyo *pYosoSagyo = pYosoSagyogun->aYosoSagyo.AddElement();
							pYosoSagyo->nSagyoNo = 1;
							if (!sInsertYosoSagyogunFlag.IsEmpty())
								pYosoSagyo->sInsertFlag = sInsertYosoSagyogunFlag;
							pYosoSagyo->nRow = g_pDataManager->AddYosoSagyoHyo();
						}
					}
				}
			}
		}
	}

// Modify ... ( ADD )
	// HKᔽt@C
	g_pDataManager->SaveKojunKiseiError();
// By Y.Itabashi (xxxxx) 2007.02.19
}

// vfƃf[^ݒ
void CManualEditDlg::SetYosoSagyoData(SYosoSagyo &cYosoSagyo, SYosoSagyoList &cYosoSagyoList)
{
	cYosoSagyo.sYosoSagyoName = cYosoSagyoList.sYosoSagyoName;
	cYosoSagyo.sYosoSagyoNo = cYosoSagyoList.sYosoSagyoNo;
	cYosoSagyo.sEnzanShiki = cYosoSagyoList.sEnzanShiki;
	cYosoSagyo.fS1 = cYosoSagyoList.fS1;
	cYosoSagyo.fS2 = cYosoSagyoList.fS2;
	cYosoSagyo.fM = cYosoSagyoList.fM;
	cYosoSagyo.fN = cYosoSagyoList.fN;
	cYosoSagyo.fEnzangoSagyoJikan = CalcEnzangoSagyoJikan(cYosoSagyoList);
	cYosoSagyo.nHassexxxndo = cYosoSagyoList.nHassexxxndo;
	cYosoSagyo.nKurikaeshiKaisu = cYosoSagyoList.nKurikaeshiKaisu;
	cYosoSagyo.fTime = CalcDaiatariSagyoJikan(cYosoSagyoList, cYosoSagyo.fEnzangoSagyoJikan);
	cYosoSagyo.sKoteibuHendobu = cYosoSagyoList.sKoteibuHendobu;
	cYosoSagyo.sSagyoFlag = cYosoSagyoList.sSagyoFlag;
	cYosoSagyo.nKijunKotei = cYosoSagyoList.nKijunKotei;
}

// ZƎԂvZ
double CManualEditDlg::CalcEnzangoSagyoJikan(SYosoSagyoList &cYosoSagyoList)
{
	CEVal cEVal;
	CString sVal;

	CString sEnzanShiki = cYosoSagyoList.sEnzanShiki;

	// ZM̒l
	sVal.Format("%10.4f", cYosoSagyoList.fM);
	sEnzanShiki.Replace("M", sVal);

	// ZN̒l
	sVal.Format("%10.4f", cYosoSagyoList.fN);
	sEnzanShiki.Replace("N", sVal);

	// ZS1̒l
	sVal.Format("%10.4f", cYosoSagyoList.fS1);
	sEnzanShiki.Replace("S1", sVal);

	// ZS2̒l
	sVal.Format("%10.4f", cYosoSagyoList.fS2);
	sEnzanShiki.Replace("S2", sVal);

	// ZvZ
	return cEVal.GetValue(sEnzanShiki);
}

// 䓖ƎԂvZ
double CManualEditDlg::CalcDaiatariSagyoJikan(SYosoSagyoList &cYosoSagyoList, double fEnzangoSagyoJikan)
{
	// Z̍Ǝԁpx~JԂ
	if (cYosoSagyoList.nHassexxxndo != 0)
		return fEnzangoSagyoJikan / cYosoSagyoList.nHassexxxndo * cYosoSagyoList.nKurikaeshiKaisu;
	else
		return 0;
}

// Sp̃A_[o[A𔼊pɕϊ
CString CManualEditDlg::ConvertHankaku(LPCTSTR pText)
{
	CString sText(pText);
	g_pDataManager->ConvertHankaku(sText);
	return sText;
}
